/*
 * Copyright (c) 2005-2007 Obeo
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */

package fr.obeo.acceleo.chain.ui.debug;

import org.eclipse.debug.core.sourcelookup.AbstractSourceLookupDirector;
import org.eclipse.debug.core.sourcelookup.ISourceLookupParticipant;

/**
 * There is one source lookup participant.
 * 
 * @author www.obeo.fr
 * 
 */
public class AcceleoSourceLookupDirector extends AbstractSourceLookupDirector {

	/* (non-Javadoc) */
	public void initializeParticipants() {
		addParticipants(new ISourceLookupParticipant[] { new AcceleoSourceLookupParticipant() });
	}

}
