/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml13.behavioral_elements.state_machines.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Action;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Common_behaviorPackage;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Event;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Guard;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.State;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.StateMachine;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.StateVertex;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.State_machinesPackage;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition;
import fr.obeo.acceleo.uml13.foundation.core.Binding;
import fr.obeo.acceleo.uml13.foundation.core.CorePackage;
import fr.obeo.acceleo.uml13.foundation.core.Namespace;
import fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Extension_mechanismsPackage;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Stereotype;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Transition</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.impl.TransitionImpl#getGuard <em>Guard</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.impl.TransitionImpl#getEffect <em>Effect</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.impl.TransitionImpl#getState <em>State</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.impl.TransitionImpl#getTrigger <em>Trigger</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.impl.TransitionImpl#getStateMachine <em>State Machine</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.impl.TransitionImpl#getSource <em>Source</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.impl.TransitionImpl#getTarget <em>Target</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class TransitionImpl extends ModelElementImpl implements Transition {
	/**
	 * The cached value of the '{@link #getGuard() <em>Guard</em>}'
	 * containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getGuard()
	 * @generated
	 * @ordered
	 */
	protected Guard guard = null;

	/**
	 * The cached value of the '{@link #getEffect() <em>Effect</em>}'
	 * containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getEffect()
	 * @generated
	 * @ordered
	 */
	protected Action effect = null;

	/**
	 * The cached value of the '{@link #getTrigger() <em>Trigger</em>}'
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getTrigger()
	 * @generated
	 * @ordered
	 */
	protected Event trigger = null;

	/**
	 * The cached value of the '{@link #getSource() <em>Source</em>}'
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getSource()
	 * @generated
	 * @ordered
	 */
	protected StateVertex source = null;

	/**
	 * The cached value of the '{@link #getTarget() <em>Target</em>}'
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getTarget()
	 * @generated
	 * @ordered
	 */
	protected StateVertex target = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected TransitionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return State_machinesPackage.eINSTANCE.getTransition();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Guard getGuard() {
		return guard;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetGuard(Guard newGuard, NotificationChain msgs) {
		Guard oldGuard = guard;
		guard = newGuard;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, State_machinesPackage.TRANSITION__GUARD, oldGuard, newGuard);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setGuard(Guard newGuard) {
		if (newGuard != guard) {
			NotificationChain msgs = null;
			if (guard != null)
				msgs = ((InternalEObject) guard).eInverseRemove(this, State_machinesPackage.GUARD__TRANSITION, Guard.class, msgs);
			if (newGuard != null)
				msgs = ((InternalEObject) newGuard).eInverseAdd(this, State_machinesPackage.GUARD__TRANSITION, Guard.class, msgs);
			msgs = basicSetGuard(newGuard, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, State_machinesPackage.TRANSITION__GUARD, newGuard, newGuard));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Action getEffect() {
		return effect;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetEffect(Action newEffect, NotificationChain msgs) {
		Action oldEffect = effect;
		effect = newEffect;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, State_machinesPackage.TRANSITION__EFFECT, oldEffect, newEffect);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setEffect(Action newEffect) {
		if (newEffect != effect) {
			NotificationChain msgs = null;
			if (effect != null)
				msgs = ((InternalEObject) effect).eInverseRemove(this, Common_behaviorPackage.ACTION__TRANSITION, Action.class, msgs);
			if (newEffect != null)
				msgs = ((InternalEObject) newEffect).eInverseAdd(this, Common_behaviorPackage.ACTION__TRANSITION, Action.class, msgs);
			msgs = basicSetEffect(newEffect, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, State_machinesPackage.TRANSITION__EFFECT, newEffect, newEffect));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public State getState() {
		if (eContainerFeatureID != State_machinesPackage.TRANSITION__STATE)
			return null;
		return (State) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setState(State newState) {
		if (newState != eContainer || (eContainerFeatureID != State_machinesPackage.TRANSITION__STATE && newState != null)) {
			if (EcoreUtil.isAncestor(this, newState))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newState != null)
				msgs = ((InternalEObject) newState).eInverseAdd(this, State_machinesPackage.STATE__INTERNAL_TRANSITION, State.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newState, State_machinesPackage.TRANSITION__STATE, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, State_machinesPackage.TRANSITION__STATE, newState, newState));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Event getTrigger() {
		if (trigger != null && trigger.eIsProxy()) {
			Event oldTrigger = trigger;
			trigger = (Event) eResolveProxy((InternalEObject) trigger);
			if (trigger != oldTrigger) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, State_machinesPackage.TRANSITION__TRIGGER, oldTrigger, trigger));
			}
		}
		return trigger;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Event basicGetTrigger() {
		return trigger;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetTrigger(Event newTrigger, NotificationChain msgs) {
		Event oldTrigger = trigger;
		trigger = newTrigger;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, State_machinesPackage.TRANSITION__TRIGGER, oldTrigger, newTrigger);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setTrigger(Event newTrigger) {
		if (newTrigger != trigger) {
			NotificationChain msgs = null;
			if (trigger != null)
				msgs = ((InternalEObject) trigger).eInverseRemove(this, State_machinesPackage.EVENT__TRANSITION, Event.class, msgs);
			if (newTrigger != null)
				msgs = ((InternalEObject) newTrigger).eInverseAdd(this, State_machinesPackage.EVENT__TRANSITION, Event.class, msgs);
			msgs = basicSetTrigger(newTrigger, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, State_machinesPackage.TRANSITION__TRIGGER, newTrigger, newTrigger));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public StateMachine getStateMachine() {
		if (eContainerFeatureID != State_machinesPackage.TRANSITION__STATE_MACHINE)
			return null;
		return (StateMachine) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setStateMachine(StateMachine newStateMachine) {
		if (newStateMachine != eContainer || (eContainerFeatureID != State_machinesPackage.TRANSITION__STATE_MACHINE && newStateMachine != null)) {
			if (EcoreUtil.isAncestor(this, newStateMachine))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newStateMachine != null)
				msgs = ((InternalEObject) newStateMachine).eInverseAdd(this, State_machinesPackage.STATE_MACHINE__TRANSITIONS, StateMachine.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newStateMachine, State_machinesPackage.TRANSITION__STATE_MACHINE, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, State_machinesPackage.TRANSITION__STATE_MACHINE, newStateMachine, newStateMachine));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public StateVertex getSource() {
		if (source != null && source.eIsProxy()) {
			StateVertex oldSource = source;
			source = (StateVertex) eResolveProxy((InternalEObject) source);
			if (source != oldSource) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, State_machinesPackage.TRANSITION__SOURCE, oldSource, source));
			}
		}
		return source;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public StateVertex basicGetSource() {
		return source;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetSource(StateVertex newSource, NotificationChain msgs) {
		StateVertex oldSource = source;
		source = newSource;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, State_machinesPackage.TRANSITION__SOURCE, oldSource, newSource);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setSource(StateVertex newSource) {
		if (newSource != source) {
			NotificationChain msgs = null;
			if (source != null)
				msgs = ((InternalEObject) source).eInverseRemove(this, State_machinesPackage.STATE_VERTEX__OUTGOING, StateVertex.class, msgs);
			if (newSource != null)
				msgs = ((InternalEObject) newSource).eInverseAdd(this, State_machinesPackage.STATE_VERTEX__OUTGOING, StateVertex.class, msgs);
			msgs = basicSetSource(newSource, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, State_machinesPackage.TRANSITION__SOURCE, newSource, newSource));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public StateVertex getTarget() {
		if (target != null && target.eIsProxy()) {
			StateVertex oldTarget = target;
			target = (StateVertex) eResolveProxy((InternalEObject) target);
			if (target != oldTarget) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, State_machinesPackage.TRANSITION__TARGET, oldTarget, target));
			}
		}
		return target;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public StateVertex basicGetTarget() {
		return target;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetTarget(StateVertex newTarget, NotificationChain msgs) {
		StateVertex oldTarget = target;
		target = newTarget;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, State_machinesPackage.TRANSITION__TARGET, oldTarget, newTarget);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setTarget(StateVertex newTarget) {
		if (newTarget != target) {
			NotificationChain msgs = null;
			if (target != null)
				msgs = ((InternalEObject) target).eInverseRemove(this, State_machinesPackage.STATE_VERTEX__INCOMING, StateVertex.class, msgs);
			if (newTarget != null)
				msgs = ((InternalEObject) newTarget).eInverseAdd(this, State_machinesPackage.STATE_VERTEX__INCOMING, StateVertex.class, msgs);
			msgs = basicSetTarget(newTarget, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, State_machinesPackage.TRANSITION__TARGET, newTarget, newTarget));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case State_machinesPackage.TRANSITION__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, State_machinesPackage.TRANSITION__NAMESPACE, msgs);
			case State_machinesPackage.TRANSITION__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__BINDING:
				if (binding != null)
					msgs = ((InternalEObject) binding).eInverseRemove(this, CorePackage.BINDING__ARGUMENT, Binding.class, msgs);
				return basicSetBinding((Binding) otherEnd, msgs);
			case State_machinesPackage.TRANSITION__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__STEREOTYPE:
				if (stereotype != null)
					msgs = ((InternalEObject) stereotype).eInverseRemove(this, Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT, Stereotype.class, msgs);
				return basicSetStereotype((Stereotype) otherEnd, msgs);
			case State_machinesPackage.TRANSITION__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__GUARD:
				if (guard != null)
					msgs = ((InternalEObject) guard).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - State_machinesPackage.TRANSITION__GUARD, null, msgs);
				return basicSetGuard((Guard) otherEnd, msgs);
			case State_machinesPackage.TRANSITION__EFFECT:
				if (effect != null)
					msgs = ((InternalEObject) effect).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - State_machinesPackage.TRANSITION__EFFECT, null, msgs);
				return basicSetEffect((Action) otherEnd, msgs);
			case State_machinesPackage.TRANSITION__STATE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, State_machinesPackage.TRANSITION__STATE, msgs);
			case State_machinesPackage.TRANSITION__TRIGGER:
				if (trigger != null)
					msgs = ((InternalEObject) trigger).eInverseRemove(this, State_machinesPackage.EVENT__TRANSITION, Event.class, msgs);
				return basicSetTrigger((Event) otherEnd, msgs);
			case State_machinesPackage.TRANSITION__STATE_MACHINE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, State_machinesPackage.TRANSITION__STATE_MACHINE, msgs);
			case State_machinesPackage.TRANSITION__SOURCE:
				if (source != null)
					msgs = ((InternalEObject) source).eInverseRemove(this, State_machinesPackage.STATE_VERTEX__OUTGOING, StateVertex.class, msgs);
				return basicSetSource((StateVertex) otherEnd, msgs);
			case State_machinesPackage.TRANSITION__TARGET:
				if (target != null)
					msgs = ((InternalEObject) target).eInverseRemove(this, State_machinesPackage.STATE_VERTEX__INCOMING, StateVertex.class, msgs);
				return basicSetTarget((StateVertex) otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case State_machinesPackage.TRANSITION__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__NAMESPACE:
				return eBasicSetContainer(null, State_machinesPackage.TRANSITION__NAMESPACE, msgs);
			case State_machinesPackage.TRANSITION__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__BINDING:
				return basicSetBinding(null, msgs);
			case State_machinesPackage.TRANSITION__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__STEREOTYPE:
				return basicSetStereotype(null, msgs);
			case State_machinesPackage.TRANSITION__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.TRANSITION__GUARD:
				return basicSetGuard(null, msgs);
			case State_machinesPackage.TRANSITION__EFFECT:
				return basicSetEffect(null, msgs);
			case State_machinesPackage.TRANSITION__STATE:
				return eBasicSetContainer(null, State_machinesPackage.TRANSITION__STATE, msgs);
			case State_machinesPackage.TRANSITION__TRIGGER:
				return basicSetTrigger(null, msgs);
			case State_machinesPackage.TRANSITION__STATE_MACHINE:
				return eBasicSetContainer(null, State_machinesPackage.TRANSITION__STATE_MACHINE, msgs);
			case State_machinesPackage.TRANSITION__SOURCE:
				return basicSetSource(null, msgs);
			case State_machinesPackage.TRANSITION__TARGET:
				return basicSetTarget(null, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case State_machinesPackage.TRANSITION__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			case State_machinesPackage.TRANSITION__STATE:
				return eContainer.eInverseRemove(this, State_machinesPackage.STATE__INTERNAL_TRANSITION, State.class, msgs);
			case State_machinesPackage.TRANSITION__STATE_MACHINE:
				return eContainer.eInverseRemove(this, State_machinesPackage.STATE_MACHINE__TRANSITIONS, StateMachine.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case State_machinesPackage.TRANSITION__ELEMENT_IMPORT:
			return getElementImport();
		case State_machinesPackage.TRANSITION__NAME:
			return getName();
		case State_machinesPackage.TRANSITION__VISIBILITY:
			return getVisibility();
		case State_machinesPackage.TRANSITION__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case State_machinesPackage.TRANSITION__NAMESPACE:
			return getNamespace();
		case State_machinesPackage.TRANSITION__CLIENT_DEPENDENCY:
			return getClientDependency();
		case State_machinesPackage.TRANSITION__CONSTRAINT:
			return getConstraint();
		case State_machinesPackage.TRANSITION__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case State_machinesPackage.TRANSITION__PRESENTATION:
			return getPresentation();
		case State_machinesPackage.TRANSITION__TARGET_FLOW:
			return getTargetFlow();
		case State_machinesPackage.TRANSITION__SOURCE_FLOW:
			return getSourceFlow();
		case State_machinesPackage.TRANSITION__TEMPLATE_PARAMETER3:
			return getTemplateParameter3();
		case State_machinesPackage.TRANSITION__BINDING:
			if (resolve)
				return getBinding();
			return basicGetBinding();
		case State_machinesPackage.TRANSITION__COMMENT:
			return getComment();
		case State_machinesPackage.TRANSITION__ELEMENT_RESIDENCE:
			return getElementResidence();
		case State_machinesPackage.TRANSITION__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case State_machinesPackage.TRANSITION__TEMPLATE_PARAMETER2:
			return getTemplateParameter2();
		case State_machinesPackage.TRANSITION__STEREOTYPE:
			if (resolve)
				return getStereotype();
			return basicGetStereotype();
		case State_machinesPackage.TRANSITION__TAGGED_VALUE:
			return getTaggedValue();
		case State_machinesPackage.TRANSITION__BEHAVIOR:
			return getBehavior();
		case State_machinesPackage.TRANSITION__CLASSIFIER_ROLE:
			return getClassifierRole();
		case State_machinesPackage.TRANSITION__COLLABORATION:
			return getCollaboration();
		case State_machinesPackage.TRANSITION__PARTITION:
			return getPartition();
		case State_machinesPackage.TRANSITION__GUARD:
			return getGuard();
		case State_machinesPackage.TRANSITION__EFFECT:
			return getEffect();
		case State_machinesPackage.TRANSITION__STATE:
			return getState();
		case State_machinesPackage.TRANSITION__TRIGGER:
			if (resolve)
				return getTrigger();
			return basicGetTrigger();
		case State_machinesPackage.TRANSITION__STATE_MACHINE:
			return getStateMachine();
		case State_machinesPackage.TRANSITION__SOURCE:
			if (resolve)
				return getSource();
			return basicGetSource();
		case State_machinesPackage.TRANSITION__TARGET:
			if (resolve)
				return getTarget();
			return basicGetTarget();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case State_machinesPackage.TRANSITION__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case State_machinesPackage.TRANSITION__NAME:
			setName((String) newValue);
			return;
		case State_machinesPackage.TRANSITION__VISIBILITY:
			setVisibility((String) newValue);
			return;
		case State_machinesPackage.TRANSITION__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case State_machinesPackage.TRANSITION__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case State_machinesPackage.TRANSITION__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case State_machinesPackage.TRANSITION__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case State_machinesPackage.TRANSITION__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case State_machinesPackage.TRANSITION__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case State_machinesPackage.TRANSITION__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case State_machinesPackage.TRANSITION__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case State_machinesPackage.TRANSITION__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			getTemplateParameter3().addAll((Collection) newValue);
			return;
		case State_machinesPackage.TRANSITION__BINDING:
			setBinding((Binding) newValue);
			return;
		case State_machinesPackage.TRANSITION__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case State_machinesPackage.TRANSITION__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case State_machinesPackage.TRANSITION__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case State_machinesPackage.TRANSITION__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			getTemplateParameter2().addAll((Collection) newValue);
			return;
		case State_machinesPackage.TRANSITION__STEREOTYPE:
			setStereotype((Stereotype) newValue);
			return;
		case State_machinesPackage.TRANSITION__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case State_machinesPackage.TRANSITION__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case State_machinesPackage.TRANSITION__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case State_machinesPackage.TRANSITION__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case State_machinesPackage.TRANSITION__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case State_machinesPackage.TRANSITION__GUARD:
			setGuard((Guard) newValue);
			return;
		case State_machinesPackage.TRANSITION__EFFECT:
			setEffect((Action) newValue);
			return;
		case State_machinesPackage.TRANSITION__STATE:
			setState((State) newValue);
			return;
		case State_machinesPackage.TRANSITION__TRIGGER:
			setTrigger((Event) newValue);
			return;
		case State_machinesPackage.TRANSITION__STATE_MACHINE:
			setStateMachine((StateMachine) newValue);
			return;
		case State_machinesPackage.TRANSITION__SOURCE:
			setSource((StateVertex) newValue);
			return;
		case State_machinesPackage.TRANSITION__TARGET:
			setTarget((StateVertex) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case State_machinesPackage.TRANSITION__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case State_machinesPackage.TRANSITION__NAME:
			setName(NAME_EDEFAULT);
			return;
		case State_machinesPackage.TRANSITION__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case State_machinesPackage.TRANSITION__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case State_machinesPackage.TRANSITION__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case State_machinesPackage.TRANSITION__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case State_machinesPackage.TRANSITION__CONSTRAINT:
			getConstraint().clear();
			return;
		case State_machinesPackage.TRANSITION__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case State_machinesPackage.TRANSITION__PRESENTATION:
			getPresentation().clear();
			return;
		case State_machinesPackage.TRANSITION__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case State_machinesPackage.TRANSITION__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case State_machinesPackage.TRANSITION__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			return;
		case State_machinesPackage.TRANSITION__BINDING:
			setBinding((Binding) null);
			return;
		case State_machinesPackage.TRANSITION__COMMENT:
			getComment().clear();
			return;
		case State_machinesPackage.TRANSITION__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case State_machinesPackage.TRANSITION__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case State_machinesPackage.TRANSITION__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			return;
		case State_machinesPackage.TRANSITION__STEREOTYPE:
			setStereotype((Stereotype) null);
			return;
		case State_machinesPackage.TRANSITION__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case State_machinesPackage.TRANSITION__BEHAVIOR:
			getBehavior().clear();
			return;
		case State_machinesPackage.TRANSITION__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case State_machinesPackage.TRANSITION__COLLABORATION:
			getCollaboration().clear();
			return;
		case State_machinesPackage.TRANSITION__PARTITION:
			getPartition().clear();
			return;
		case State_machinesPackage.TRANSITION__GUARD:
			setGuard((Guard) null);
			return;
		case State_machinesPackage.TRANSITION__EFFECT:
			setEffect((Action) null);
			return;
		case State_machinesPackage.TRANSITION__STATE:
			setState((State) null);
			return;
		case State_machinesPackage.TRANSITION__TRIGGER:
			setTrigger((Event) null);
			return;
		case State_machinesPackage.TRANSITION__STATE_MACHINE:
			setStateMachine((StateMachine) null);
			return;
		case State_machinesPackage.TRANSITION__SOURCE:
			setSource((StateVertex) null);
			return;
		case State_machinesPackage.TRANSITION__TARGET:
			setTarget((StateVertex) null);
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case State_machinesPackage.TRANSITION__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case State_machinesPackage.TRANSITION__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case State_machinesPackage.TRANSITION__VISIBILITY:
			return VISIBILITY_EDEFAULT == null ? visibility != null : !VISIBILITY_EDEFAULT.equals(visibility);
		case State_machinesPackage.TRANSITION__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case State_machinesPackage.TRANSITION__NAMESPACE:
			return getNamespace() != null;
		case State_machinesPackage.TRANSITION__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case State_machinesPackage.TRANSITION__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case State_machinesPackage.TRANSITION__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case State_machinesPackage.TRANSITION__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case State_machinesPackage.TRANSITION__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case State_machinesPackage.TRANSITION__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case State_machinesPackage.TRANSITION__TEMPLATE_PARAMETER3:
			return templateParameter3 != null && !templateParameter3.isEmpty();
		case State_machinesPackage.TRANSITION__BINDING:
			return binding != null;
		case State_machinesPackage.TRANSITION__COMMENT:
			return comment != null && !comment.isEmpty();
		case State_machinesPackage.TRANSITION__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case State_machinesPackage.TRANSITION__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case State_machinesPackage.TRANSITION__TEMPLATE_PARAMETER2:
			return templateParameter2 != null && !templateParameter2.isEmpty();
		case State_machinesPackage.TRANSITION__STEREOTYPE:
			return stereotype != null;
		case State_machinesPackage.TRANSITION__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case State_machinesPackage.TRANSITION__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case State_machinesPackage.TRANSITION__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case State_machinesPackage.TRANSITION__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case State_machinesPackage.TRANSITION__PARTITION:
			return partition != null && !partition.isEmpty();
		case State_machinesPackage.TRANSITION__GUARD:
			return guard != null;
		case State_machinesPackage.TRANSITION__EFFECT:
			return effect != null;
		case State_machinesPackage.TRANSITION__STATE:
			return getState() != null;
		case State_machinesPackage.TRANSITION__TRIGGER:
			return trigger != null;
		case State_machinesPackage.TRANSITION__STATE_MACHINE:
			return getStateMachine() != null;
		case State_machinesPackage.TRANSITION__SOURCE:
			return source != null;
		case State_machinesPackage.TRANSITION__TARGET:
			return target != null;
		}
		return eDynamicIsSet(eFeature);
	}

} // TransitionImpl
