/*
 * Copyright (c) 2005-2007 Obeo
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */

package fr.obeo.acceleo.tools.ui.views;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.pde.internal.runtime.logview.LogEntry;

/**
 * The logs view for the acceleo tools.
 * 
 * @author www.obeo.fr
 * 
 */
public class LogView extends org.eclipse.pde.internal.runtime.logview.LogView {

	/* (non-Javadoc) */
	public LogEntry[] getLogs() {
		List result = new ArrayList();
		LogEntry[] entries = super.getLogs();
		for (int i = 0; i < entries.length; i++) {
			LogEntry entry = entries[i];
			if (entry.getPluginId().startsWith("fr.obeo")) { //$NON-NLS-1$
				result.add(entry);
			}
		}
		return (LogEntry[]) result.toArray(new LogEntry[result.size()]);
	}

}
