/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Common_behaviorPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Reception;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Signal;
import fr.obeo.acceleo.uml14.foundation.core.Classifier;
import fr.obeo.acceleo.uml14.foundation.core.CorePackage;
import fr.obeo.acceleo.uml14.foundation.core.Namespace;
import fr.obeo.acceleo.uml14.foundation.core.TemplateParameter;
import fr.obeo.acceleo.uml14.foundation.core.impl.BehavioralFeatureImpl;
import fr.obeo.acceleo.uml14.foundation.data_types.ScopeKind;
import fr.obeo.acceleo.uml14.foundation.data_types.VisibilityKind;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Reception</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.ReceptionImpl#getSpecification <em>Specification</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.ReceptionImpl#isIsRoot <em>Is Root</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.ReceptionImpl#isIsLeaf <em>Is Leaf</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.ReceptionImpl#isIsAbstract <em>Is Abstract</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.ReceptionImpl#getSignal <em>Signal</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class ReceptionImpl extends BehavioralFeatureImpl implements Reception {
	/**
	 * The default value of the '{@link #getSpecification() <em>Specification</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getSpecification()
	 * @generated
	 * @ordered
	 */
	protected static final String SPECIFICATION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getSpecification() <em>Specification</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getSpecification()
	 * @generated
	 * @ordered
	 */
	protected String specification = SPECIFICATION_EDEFAULT;

	/**
	 * The default value of the '{@link #isIsRoot() <em>Is Root</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #isIsRoot()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_ROOT_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIsRoot() <em>Is Root</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #isIsRoot()
	 * @generated
	 * @ordered
	 */
	protected boolean isRoot = IS_ROOT_EDEFAULT;

	/**
	 * The default value of the '{@link #isIsLeaf() <em>Is Leaf</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #isIsLeaf()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_LEAF_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIsLeaf() <em>Is Leaf</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #isIsLeaf()
	 * @generated
	 * @ordered
	 */
	protected boolean isLeaf = IS_LEAF_EDEFAULT;

	/**
	 * The default value of the '{@link #isIsAbstract() <em>Is Abstract</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #isIsAbstract()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_ABSTRACT_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIsAbstract() <em>Is Abstract</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #isIsAbstract()
	 * @generated
	 * @ordered
	 */
	protected boolean isAbstract = IS_ABSTRACT_EDEFAULT;

	/**
	 * The cached value of the '{@link #getSignal() <em>Signal</em>}'
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getSignal()
	 * @generated
	 * @ordered
	 */
	protected Signal signal = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ReceptionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return Common_behaviorPackage.eINSTANCE.getReception();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getSpecification() {
		return specification;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setSpecification(String newSpecification) {
		String oldSpecification = specification;
		specification = newSpecification;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.RECEPTION__SPECIFICATION, oldSpecification, specification));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean isIsRoot() {
		return isRoot;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setIsRoot(boolean newIsRoot) {
		boolean oldIsRoot = isRoot;
		isRoot = newIsRoot;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.RECEPTION__IS_ROOT, oldIsRoot, isRoot));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean isIsLeaf() {
		return isLeaf;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setIsLeaf(boolean newIsLeaf) {
		boolean oldIsLeaf = isLeaf;
		isLeaf = newIsLeaf;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.RECEPTION__IS_LEAF, oldIsLeaf, isLeaf));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean isIsAbstract() {
		return isAbstract;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setIsAbstract(boolean newIsAbstract) {
		boolean oldIsAbstract = isAbstract;
		isAbstract = newIsAbstract;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.RECEPTION__IS_ABSTRACT, oldIsAbstract, isAbstract));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Signal getSignal() {
		if (signal != null && signal.eIsProxy()) {
			Signal oldSignal = signal;
			signal = (Signal) eResolveProxy((InternalEObject) signal);
			if (signal != oldSignal) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, Common_behaviorPackage.RECEPTION__SIGNAL, oldSignal, signal));
			}
		}
		return signal;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Signal basicGetSignal() {
		return signal;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetSignal(Signal newSignal, NotificationChain msgs) {
		Signal oldSignal = signal;
		signal = newSignal;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.RECEPTION__SIGNAL, oldSignal, newSignal);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setSignal(Signal newSignal) {
		if (newSignal != signal) {
			NotificationChain msgs = null;
			if (signal != null)
				msgs = ((InternalEObject) signal).eInverseRemove(this, Common_behaviorPackage.SIGNAL__RECEPTION, Signal.class, msgs);
			if (newSignal != null)
				msgs = ((InternalEObject) newSignal).eInverseAdd(this, Common_behaviorPackage.SIGNAL__RECEPTION, Signal.class, msgs);
			msgs = basicSetSignal(newSignal, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.RECEPTION__SIGNAL, newSignal, newSignal));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Common_behaviorPackage.RECEPTION__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.RECEPTION__NAMESPACE, msgs);
			case Common_behaviorPackage.RECEPTION__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__PARAMETER_TEMPLATE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.RECEPTION__PARAMETER_TEMPLATE, msgs);
			case Common_behaviorPackage.RECEPTION__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__OWNER:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.RECEPTION__OWNER, msgs);
			case Common_behaviorPackage.RECEPTION__PARAMETER:
				return ((InternalEList) getParameter()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__RAISED_SIGNAL:
				return ((InternalEList) getRaisedSignal()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__SIGNAL:
				if (signal != null)
					msgs = ((InternalEObject) signal).eInverseRemove(this, Common_behaviorPackage.SIGNAL__RECEPTION, Signal.class, msgs);
				return basicSetSignal((Signal) otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Common_behaviorPackage.RECEPTION__NAMESPACE:
				return eBasicSetContainer(null, Common_behaviorPackage.RECEPTION__NAMESPACE, msgs);
			case Common_behaviorPackage.RECEPTION__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__PARAMETER_TEMPLATE:
				return eBasicSetContainer(null, Common_behaviorPackage.RECEPTION__PARAMETER_TEMPLATE, msgs);
			case Common_behaviorPackage.RECEPTION__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__OWNER:
				return eBasicSetContainer(null, Common_behaviorPackage.RECEPTION__OWNER, msgs);
			case Common_behaviorPackage.RECEPTION__PARAMETER:
				return ((InternalEList) getParameter()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__RAISED_SIGNAL:
				return ((InternalEList) getRaisedSignal()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.RECEPTION__SIGNAL:
				return basicSetSignal(null, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case Common_behaviorPackage.RECEPTION__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			case Common_behaviorPackage.RECEPTION__PARAMETER_TEMPLATE:
				return eContainer.eInverseRemove(this, CorePackage.TEMPLATE_PARAMETER__PARAMETER, TemplateParameter.class, msgs);
			case Common_behaviorPackage.RECEPTION__OWNER:
				return eContainer.eInverseRemove(this, CorePackage.CLASSIFIER__FEATURE, Classifier.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.RECEPTION__NAME:
			return getName();
		case Common_behaviorPackage.RECEPTION__VISIBILITY:
			return getVisibility();
		case Common_behaviorPackage.RECEPTION__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case Common_behaviorPackage.RECEPTION__NAMESPACE:
			return getNamespace();
		case Common_behaviorPackage.RECEPTION__CLIENT_DEPENDENCY:
			return getClientDependency();
		case Common_behaviorPackage.RECEPTION__CONSTRAINT:
			return getConstraint();
		case Common_behaviorPackage.RECEPTION__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case Common_behaviorPackage.RECEPTION__PRESENTATION:
			return getPresentation();
		case Common_behaviorPackage.RECEPTION__TARGET_FLOW:
			return getTargetFlow();
		case Common_behaviorPackage.RECEPTION__SOURCE_FLOW:
			return getSourceFlow();
		case Common_behaviorPackage.RECEPTION__DEFAULTED_PARAMETER:
			return getDefaultedParameter();
		case Common_behaviorPackage.RECEPTION__COMMENT:
			return getComment();
		case Common_behaviorPackage.RECEPTION__ELEMENT_RESIDENCE:
			return getElementResidence();
		case Common_behaviorPackage.RECEPTION__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case Common_behaviorPackage.RECEPTION__PARAMETER_TEMPLATE:
			return getParameterTemplate();
		case Common_behaviorPackage.RECEPTION__STEREOTYPE:
			return getStereotype();
		case Common_behaviorPackage.RECEPTION__TAGGED_VALUE:
			return getTaggedValue();
		case Common_behaviorPackage.RECEPTION__REFERENCE_TAG:
			return getReferenceTag();
		case Common_behaviorPackage.RECEPTION__TEMPLATE_ARGUMENT:
			return getTemplateArgument();
		case Common_behaviorPackage.RECEPTION__BEHAVIOR:
			return getBehavior();
		case Common_behaviorPackage.RECEPTION__CLASSIFIER_ROLE:
			return getClassifierRole();
		case Common_behaviorPackage.RECEPTION__COLLABORATION:
			return getCollaboration();
		case Common_behaviorPackage.RECEPTION__COLLABORATION_INSTANCE_SET:
			return getCollaborationInstanceSet();
		case Common_behaviorPackage.RECEPTION__PARTITION:
			return getPartition();
		case Common_behaviorPackage.RECEPTION__ELEMENT_IMPORT:
			return getElementImport();
		case Common_behaviorPackage.RECEPTION__OWNER_SCOPE:
			return getOwnerScope();
		case Common_behaviorPackage.RECEPTION__OWNER:
			return getOwner();
		case Common_behaviorPackage.RECEPTION__IS_QUERY:
			return isIsQuery() ? Boolean.TRUE : Boolean.FALSE;
		case Common_behaviorPackage.RECEPTION__PARAMETER:
			return getParameter();
		case Common_behaviorPackage.RECEPTION__RAISED_SIGNAL:
			return getRaisedSignal();
		case Common_behaviorPackage.RECEPTION__SPECIFICATION:
			return getSpecification();
		case Common_behaviorPackage.RECEPTION__IS_ROOT:
			return isIsRoot() ? Boolean.TRUE : Boolean.FALSE;
		case Common_behaviorPackage.RECEPTION__IS_LEAF:
			return isIsLeaf() ? Boolean.TRUE : Boolean.FALSE;
		case Common_behaviorPackage.RECEPTION__IS_ABSTRACT:
			return isIsAbstract() ? Boolean.TRUE : Boolean.FALSE;
		case Common_behaviorPackage.RECEPTION__SIGNAL:
			if (resolve)
				return getSignal();
			return basicGetSignal();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.RECEPTION__NAME:
			setName((String) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__VISIBILITY:
			setVisibility((VisibilityKind) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case Common_behaviorPackage.RECEPTION__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			getDefaultedParameter().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__STEREOTYPE:
			getStereotype().clear();
			getStereotype().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__REFERENCE_TAG:
			getReferenceTag().clear();
			getReferenceTag().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			getTemplateArgument().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			getCollaborationInstanceSet().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__OWNER_SCOPE:
			setOwnerScope((ScopeKind) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__OWNER:
			setOwner((Classifier) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__IS_QUERY:
			setIsQuery(((Boolean) newValue).booleanValue());
			return;
		case Common_behaviorPackage.RECEPTION__PARAMETER:
			getParameter().clear();
			getParameter().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__RAISED_SIGNAL:
			getRaisedSignal().clear();
			getRaisedSignal().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__SPECIFICATION:
			setSpecification((String) newValue);
			return;
		case Common_behaviorPackage.RECEPTION__IS_ROOT:
			setIsRoot(((Boolean) newValue).booleanValue());
			return;
		case Common_behaviorPackage.RECEPTION__IS_LEAF:
			setIsLeaf(((Boolean) newValue).booleanValue());
			return;
		case Common_behaviorPackage.RECEPTION__IS_ABSTRACT:
			setIsAbstract(((Boolean) newValue).booleanValue());
			return;
		case Common_behaviorPackage.RECEPTION__SIGNAL:
			setSignal((Signal) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.RECEPTION__NAME:
			setName(NAME_EDEFAULT);
			return;
		case Common_behaviorPackage.RECEPTION__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case Common_behaviorPackage.RECEPTION__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case Common_behaviorPackage.RECEPTION__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case Common_behaviorPackage.RECEPTION__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case Common_behaviorPackage.RECEPTION__CONSTRAINT:
			getConstraint().clear();
			return;
		case Common_behaviorPackage.RECEPTION__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case Common_behaviorPackage.RECEPTION__PRESENTATION:
			getPresentation().clear();
			return;
		case Common_behaviorPackage.RECEPTION__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case Common_behaviorPackage.RECEPTION__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case Common_behaviorPackage.RECEPTION__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			return;
		case Common_behaviorPackage.RECEPTION__COMMENT:
			getComment().clear();
			return;
		case Common_behaviorPackage.RECEPTION__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case Common_behaviorPackage.RECEPTION__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case Common_behaviorPackage.RECEPTION__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) null);
			return;
		case Common_behaviorPackage.RECEPTION__STEREOTYPE:
			getStereotype().clear();
			return;
		case Common_behaviorPackage.RECEPTION__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case Common_behaviorPackage.RECEPTION__REFERENCE_TAG:
			getReferenceTag().clear();
			return;
		case Common_behaviorPackage.RECEPTION__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			return;
		case Common_behaviorPackage.RECEPTION__BEHAVIOR:
			getBehavior().clear();
			return;
		case Common_behaviorPackage.RECEPTION__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case Common_behaviorPackage.RECEPTION__COLLABORATION:
			getCollaboration().clear();
			return;
		case Common_behaviorPackage.RECEPTION__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			return;
		case Common_behaviorPackage.RECEPTION__PARTITION:
			getPartition().clear();
			return;
		case Common_behaviorPackage.RECEPTION__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case Common_behaviorPackage.RECEPTION__OWNER_SCOPE:
			setOwnerScope(OWNER_SCOPE_EDEFAULT);
			return;
		case Common_behaviorPackage.RECEPTION__OWNER:
			setOwner((Classifier) null);
			return;
		case Common_behaviorPackage.RECEPTION__IS_QUERY:
			setIsQuery(IS_QUERY_EDEFAULT);
			return;
		case Common_behaviorPackage.RECEPTION__PARAMETER:
			getParameter().clear();
			return;
		case Common_behaviorPackage.RECEPTION__RAISED_SIGNAL:
			getRaisedSignal().clear();
			return;
		case Common_behaviorPackage.RECEPTION__SPECIFICATION:
			setSpecification(SPECIFICATION_EDEFAULT);
			return;
		case Common_behaviorPackage.RECEPTION__IS_ROOT:
			setIsRoot(IS_ROOT_EDEFAULT);
			return;
		case Common_behaviorPackage.RECEPTION__IS_LEAF:
			setIsLeaf(IS_LEAF_EDEFAULT);
			return;
		case Common_behaviorPackage.RECEPTION__IS_ABSTRACT:
			setIsAbstract(IS_ABSTRACT_EDEFAULT);
			return;
		case Common_behaviorPackage.RECEPTION__SIGNAL:
			setSignal((Signal) null);
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.RECEPTION__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case Common_behaviorPackage.RECEPTION__VISIBILITY:
			return visibility != VISIBILITY_EDEFAULT;
		case Common_behaviorPackage.RECEPTION__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case Common_behaviorPackage.RECEPTION__NAMESPACE:
			return getNamespace() != null;
		case Common_behaviorPackage.RECEPTION__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case Common_behaviorPackage.RECEPTION__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case Common_behaviorPackage.RECEPTION__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case Common_behaviorPackage.RECEPTION__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case Common_behaviorPackage.RECEPTION__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case Common_behaviorPackage.RECEPTION__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case Common_behaviorPackage.RECEPTION__DEFAULTED_PARAMETER:
			return defaultedParameter != null && !defaultedParameter.isEmpty();
		case Common_behaviorPackage.RECEPTION__COMMENT:
			return comment != null && !comment.isEmpty();
		case Common_behaviorPackage.RECEPTION__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case Common_behaviorPackage.RECEPTION__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case Common_behaviorPackage.RECEPTION__PARAMETER_TEMPLATE:
			return getParameterTemplate() != null;
		case Common_behaviorPackage.RECEPTION__STEREOTYPE:
			return stereotype != null && !stereotype.isEmpty();
		case Common_behaviorPackage.RECEPTION__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case Common_behaviorPackage.RECEPTION__REFERENCE_TAG:
			return referenceTag != null && !referenceTag.isEmpty();
		case Common_behaviorPackage.RECEPTION__TEMPLATE_ARGUMENT:
			return templateArgument != null && !templateArgument.isEmpty();
		case Common_behaviorPackage.RECEPTION__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case Common_behaviorPackage.RECEPTION__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case Common_behaviorPackage.RECEPTION__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case Common_behaviorPackage.RECEPTION__COLLABORATION_INSTANCE_SET:
			return collaborationInstanceSet != null && !collaborationInstanceSet.isEmpty();
		case Common_behaviorPackage.RECEPTION__PARTITION:
			return partition != null && !partition.isEmpty();
		case Common_behaviorPackage.RECEPTION__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case Common_behaviorPackage.RECEPTION__OWNER_SCOPE:
			return ownerScope != OWNER_SCOPE_EDEFAULT;
		case Common_behaviorPackage.RECEPTION__OWNER:
			return getOwner() != null;
		case Common_behaviorPackage.RECEPTION__IS_QUERY:
			return isQuery != IS_QUERY_EDEFAULT;
		case Common_behaviorPackage.RECEPTION__PARAMETER:
			return parameter != null && !parameter.isEmpty();
		case Common_behaviorPackage.RECEPTION__RAISED_SIGNAL:
			return raisedSignal != null && !raisedSignal.isEmpty();
		case Common_behaviorPackage.RECEPTION__SPECIFICATION:
			return SPECIFICATION_EDEFAULT == null ? specification != null : !SPECIFICATION_EDEFAULT.equals(specification);
		case Common_behaviorPackage.RECEPTION__IS_ROOT:
			return isRoot != IS_ROOT_EDEFAULT;
		case Common_behaviorPackage.RECEPTION__IS_LEAF:
			return isLeaf != IS_LEAF_EDEFAULT;
		case Common_behaviorPackage.RECEPTION__IS_ABSTRACT:
			return isAbstract != IS_ABSTRACT_EDEFAULT;
		case Common_behaviorPackage.RECEPTION__SIGNAL:
			return signal != null;
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (specification: "); //$NON-NLS-1$
		result.append(specification);
		result.append(", isRoot: "); //$NON-NLS-1$
		result.append(isRoot);
		result.append(", isLeaf: "); //$NON-NLS-1$
		result.append(isLeaf);
		result.append(", isAbstract: "); //$NON-NLS-1$
		result.append(isAbstract);
		result.append(')');
		return result.toString();
	}

} // ReceptionImpl
